﻿/*
 * * * Compile_AHK SETTINGS BEGIN * * *


[AHK2EXE]
Exe_File=%In_Dir%\..\Tools\Rebranding.exe
[VERSION]
Set_Version_Info=1
Company_Name=Framasoft
File_Description=Utilitaire de regriffage de Mozilla Firefox/Thunderbird
File_Version=0.4.2.0
Inc_File_Version=0
Internal_Name=Rebranding.ahk
Legal_Copyright=(c) 2015 Framakey.org
Original_Filename=Rebranding
Product_Name=Framafox/bird
Product_Version=1.1.11.2
Set_AHK_Version=1
Language_ID=56
[ICONS]
Icon_1=%In_Dir%\Rebranding.ico
Icon_2=0
Icon_3=0
Icon_4=0
Icon_5=0
Icon_6=0
Icon_7=0

* * * Compile_AHK SETTINGS END * * *
*/

; ================================================================================
; 								Rebranding 0.4
; ================================================================================
;
; 	Par fat115
; 	License : GNU/GPL
; 	Ce script permet de regriffer Mozilla Firefox/Thunderbird sans recompiler
; 	Compiler: AutoHotkey_L (http://www.autohotkey.com/).
; 	$id=Rebranding.ahk $date=2015-05-03
;
; --------------------------------------------------------------------------------
;						Copyright (C) 2010-2015 Framakey

;						Website: http://www.framakey.org

;This software is OSI Certified Open Source Software.
;OSI Certified is a certification mark of the Open Source Initiative.

;This program is free software; you can redistribute it and/or
;modify it under the terms of the GNU General Public License
;as published by the Free Software Foundation; either version 2
;of the License, or (at your option) any later version.

;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
;GNU General Public License for more details.

;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA	02110-1301, USA.
; --------------------------------------------------------------------------------


; ================================================================================
; 								Initialisation
; ================================================================================

; On désactive l'icône de la barre des tâches
#NoTrayIcon
#NoEnv
; On force le répertoire des includes à être celui du script
#Include %A_ScriptDir%\AhkIncludes
#Include Functions.ahk
#Include VersionInfo.ahk
#Include ini.ahk
#Include ResCompile.ahk
#Include ChangeIcon.ahk
OnExit, QuitRebrand
FileEncoding, UTF-8

i_Bar := 0

; Définitions des éléments pour la récupération des IconGroups et i_LangID
CallB := RegisterCallback( "EnumResNameProc" )
CallC := RegisterCallback( "EnumResLangProc" )
IconGroups := ""

; on crée un répertoire temporaire spécifique au processus
Process, Exist
i_PID := ErrorLevel
p_PlugDir := A_Temp . "\Rebrand." . i_PID
p_TempDir := p_PlugDir . "\Rebrand"
p_ArchiveDir := p_PlugDir . "\Archive"
FileCreateDir, %p_TempDir%
FileCreateDir, %p_ArchiveDir%
FileInstall, .\ResRebrand\7za.exe, %p_PlugDir%\7za.exe
FileInstall, .\ResRebrand\bsdiff.exe, %p_PlugDir%\bsdiff.exe
FileInstall, .\ResRebrand\bspatch.exe, %p_PlugDir%\bspatc.exe
FileInstall, .\ResRebrand\appicon.ico, %p_PlugDir%\appicon.ico
FileInstall, .\ResRebrand\files.7z, %p_PlugDir%\files.7z

; Définiton et création des dossiers
p_BaseDir := A_ScriptDir
p_BaseDir := StringReplace(p_BaseDir, "\Other\Tools")
IfInString, p_BaseDir, fox
	{
	s_NewName := "Framafox"
	s_OldName := "Firefox"
	}
Else IfInString, p_BaseDir, bird
	{
	s_NewName := "Framabird"
	s_OldName := "Thunderbird"
	}
Else
	{
	s_OldName := "Firefox"
	}

; Récupérations des données de base dans l'ini
ini_load(f_IniFile, A_ScriptDir . "\identity.ini", "UTF-8")
s_AppName := ini_getValuewDefault(f_IniFile, "Main", "AppName", s_NewName)
s_VendorName:= ini_getValuewDefault(f_IniFile, "Main", "Vendor", "Framasoft")
s_OldName := ini_getValuewDefault(f_IniFile, "Main", "OriginalName", s_OldName)
s_License := ini_getValuewDefault(f_IniFile, "Main", "LicenseText", "License: MPL 1.1/GPL 2.0/LGPL 2.1")

; Définition des fichiers
f_PortLaunch := p_BaseDir . "\" . s_AppName . "Portable.exe"
f_7zExe := p_PlugDir . "\7za.exe"
f_diffExe := p_PlugDir . "\bsdiff.exe"
f_patchExe := p_PlugDir . "\bspatc.exe"
f_BKA := A_ScriptDir . "\FramaBKUp.7z"
f_BKL := p_PlugDir . "\backuplist.txt"
f_Ico := p_PlugDir . "\appicon.ico"
RunWait, %f_7zExe% x files.7z -o%p_PlugDir%\files, %p_PlugDir%, Hide

; Définition du dossier de l'application
f_AppIni = %p_BaseDir%\%s_AppName%Portable.ini
p_AppDir := p_BaseDir . "\" . IniRead(f_AppIni, s_AppName . "Portable", s_AppName . "Directory", "App\" . s_AppName)

; ================================================================================
; 								Section Principale
; ================================================================================
FileReadLine, p_UpDir, %p_AppDir%\update.path.fk, 1
p_TmpUpDir := p_UpDir
p_UpDir .= "\updates\0"
FileReadLine, s_Relaunch, %p_AppDir%\update.path.fk, 2
If (s_Relaunch = "relaunch")
	_finmess := "redémarre"
Else
	_finmess := "quitte"

Progress, A M W240 FM8 WM300 P%i_Bar%, , %s_AppName% installe les mises à jour et %_finmess%. Veuillez patienter., Mise à jour

; mise en place de l'extension de remarquage embarquée
FileCreateDir, %p_AppDir%\distribution\bundles\framabrand@framakey.org\chrome
FileCreateDir, %p_AppDir%\distribution\bundles\framabrand@framakey.org\defaults\preferences
FileInstall, .\ResRebrand\chrome.manifest, %p_AppDir%\distribution\bundles\framabrand@framakey.org\chrome.manifest, 1
FileInstall, .\ResRebrand\install.rdf, %p_AppDir%\distribution\bundles\framabrand@framakey.org\install.rdf, 1
FileInstall, .\ResRebrand\rebranding.jar, %p_AppDir%\distribution\bundles\framabrand@framakey.org\chrome\rebranding.jar, 1
FileInstall, .\ResRebrand\framabrand.js, %p_AppDir%\distribution\bundles\framabrand@framakey.org\defaults\preferences\framabrand.js, 1
FileCreateDir, %p_AppDir%\browser\extensions\framabrand@framakey.org\chrome
FileCreateDir, %p_AppDir%\browser\extensions\framabrand@framakey.org\defaults\preferences
FileInstall, .\ResRebrand\chrome.manifest, %p_AppDir%\browser\extensions\framabrand@framakey.org\chrome.manifest, 1
FileInstall, .\ResRebrand\install.rdf, %p_AppDir%\browser\extensions\framabrand@framakey.org\install.rdf, 1
FileInstall, .\ResRebrand\rebranding.jar, %p_AppDir%\browser\extensions\framabrand@framakey.org\chrome\rebranding.jar, 1
FileInstall, .\ResRebrand\framabrand.js, %p_AppDir%\browser\extensions\framabrand@framakey.org\defaults\preferences\framabrand.js, 1

; détection d'une éventuelle mise à jour à réaliser
IfExist, %p_AppDir%\update.path.fk
	{
	; remise en place de la sauvegarde
	RunWait, "%f_7zExe%" x -y "%f_BKA%", %p_ArchiveDir%, Hide
	Loop, %p_ArchiveDir%\*.patch, 0, 1
		{
		IfInString, A_LoopFileName, %s_OldName%
			RunWait, %f_patchExe% "%p_AppDir%\%s_AppName%.exe" "%p_AppDir%\%s_OldName%.exe" "%A_LoopFileFullPath%", , Hide
		Else
			{
			_dest := p_AppDir . StringReplace(StringReplace(A_LoopFileFullPath, p_ArchiveDir), ".patch")
			RunWait, %f_patchExe% "%_dest%" "%_dest%" "%A_LoopFileFullPath%", , Hide
			}
		FileDelete, %A_LoopFileFullPath%
		}
	FileMove, %p_ArchiveDir%\*.*, %p_AppDir%, 1
	UpdateProgress(5)
	; transfert des fichiers d'update
	FileCopy, %p_AppDir%\updater.exe, %p_UpDir%, 1
	FileDelete, %p_UpDir%\updater.ini
	UpdateProgress(2)
	; mise à jour
	RunWait, "%p_UpDir%\updater.exe" "%p_UpDir%" "%p_AppDir%" "%p_AppDir%", , Hide
	UpdateProgress(5)
	FileRead, f_UpStatus, %p_UpDir%\update.status
	IfNotInString, f_UpStatus, succeeded
		{
		MsgBox, 16, Erreur !, La mise à jour a échoué.`nVous devriez vérifier les mises à jour sur le site %s_VendorName%.
		FileRemoveDir, %p_TmpUpDir%, 1
		ExitApp
		}
	FileMove, %p_UpDir%\update.log, %p_AppDir%\uninstall\uninstall.update
	RunWait, "%p_AppDir%\uninstall\helper.exe" /PostUpdate, %p_AppDir%, Hide
	FileRemoveDir, %p_TmpUpDir%, 1
	UpdateProgress(1)
	}
Else
	UpdateProgress(13)

FileDelete, %p_AppDir%\update.path.fk

BackupFiles := "application.ini`n"

; on liste les fichiers à copier
Loop, %p_PlugDir%\files\*.*, 0, 1
	{
	BackupFiles .= StringReplace(A_LoopFileFullPath, p_PlugDir . "\files\") . "`n"
	}

; on liste les fichiers à supprimer
s_DelFiles := ini_getAllValues(f_IniFile, "Delete", i_Del)
BackupFiles .= s_DelFiles . "`n"

; on liste les fichiers à patcher
s_PEToPatch := ini_getAllValues(f_IniFile, "PEFilesToPatch", i_PE)
s_Patches := StringReplace(s_PEToPatch, "`n", ".patch`n", "All") . ".patch"
_ArchFiles := BackupFiles . s_Patches
BackupFiles .= s_PEToPatch
; on règle le problème des doublons
Sort, BackupFiles, U

UpdateProgress(2)

; on copie les fichiers à sauvegarder
Loop, parse, BackupFiles, `n, `r
	{
	IfInString, A_LoopField, \
		{
		SplitPath, A_LoopField, , _dir
		FileCreateDir, %p_ArchiveDir%\%_dir%
		}
	FileCopy, %p_AppDir%\%A_LoopField%, %p_ArchiveDir%\%A_LoopField%
	}

UpdateProgress(5)

; on supprime les fichiers
Loop, parse, s_DelFiles, `n, `r
	FileDelete, %p_AppDir%\%A_LoopField%
	
UpdateProgress(2)

; on met à jour application.ini en limitant les accès disques
ini_load(f_AppIni, p_AppDir . "\application.ini", "CP1252")
ini_replaceValue(f_AppIni, "Crash Reporter", "Enabled", "0")
ini_replaceKey(f_AppIni, "Crash Reporter", "ServerURL")
ini_replaceValue(f_AppIni, "App", "Name", s_AppName)
ini_replaceValue(f_AppIni, "App", "Vendor", s_VendorName)
ini_replaceValue(f_AppIni, "App", "RemotingName", s_AppName)
ini_save(f_AppIni, p_AppDir . "\application.ini", "CP1252")
ini_save(f_AppIni, p_AppDir . "\browser\application.ini", "CP1252")

UpdateProgress(2)

; on patche VERINFO
Loop, parse, s_PEToPatch, `n, `r
	{
	PEFile := p_AppDir . "\" . A_LoopField
	IfNotExist, %PEFile%
		Continue
	o_VerInfo := FileGetFullVer(PEFile)
	; on applique les modifications pour démarquer
	o_VerInfo.LegalCopyright := s_License
	o_VerInfo.CompanyName := s_VendorName
	o_VerInfo.FileDescription := StringReplace(o_VerInfo.FileDescription, s_OldName, s_AppName)
	o_VerInfo.InternalName := StringReplace(o_VerInfo.InternalName, s_OldName, s_AppName)
	o_VerInfo.OriginalFilename := StringReplace(o_VerInfo.OriginalFilename, s_OldName, s_AppName)
	o_VerInfo.LegalTrademarks := ""
	o_VerInfo.ProductName := s_AppName
	s_VSVersion := CreateRESString(o_VerInfo)
	; on convertit en binaire
	_nbBytes := StrLen(s_VSVersion) // 2
	VarSetCapacity(_memdata, _nbBytes)
	Loop, % _nbBytes
		_memadd := NumPut("0x" SubStr(s_VSVersion, (A_Index * 2) -1, 2), _memdata, A_Index-1, "UChar")
	UpdateProgress(Ceil(4 / i_PE))
	; on récupère la première valeur de langue
	i_LangID := ""
	_hModule := DllCall( "LoadLibraryEx", Str,PEFile, UInt,0, UInt,0x2 )
    DllCall("EnumResourceLanguages", UInt,_hModule, UInt,16, UInt,1, UInt,CallC, UInt,0 )
    DllCall( "FreeLibrary", UInt,_hModule )
	IfInString, i_LangID, |
		i_LangID := SubStr(i_LangID, 1, InStr(i_LangID, "|") - 1)
	; on patche le binaire
	_hModule := DllCall("BeginUpdateResource", Str, PEFile, UInt, 0, Ptr)
	DllCall("UpdateResource", Ptr, _hModule, Ptr, 16, Ptr, 1, UInt, i_LangID, Ptr, &_memdata, UInt, _nbBytes, UInt)
	DllCall("EndUpdateResource", Ptr, _hModule, UInt, 0)
	VarSetCapacity(_memdata, 0)
	UpdateProgress(Ceil(16 / i_PE))
	}

; on renomme l'exécutable principal
f_AppExe := p_AppDir . "\" . s_AppName . ".exe"
FileMove, %p_AppDir%\%s_OldName%.exe, %f_AppExe%, 1

; on récupère les noms des IconGroups présents dans l'exe
_hModule := DllCall( "LoadLibraryEx", Str,f_AppExe, UInt,0, UInt,0x2 )
DllCall("EnumResourceNames", UInt,_hModule, UInt,14, UInt,CallB, UInt,0 )
DllCall( "FreeLibrary", UInt,_hModule )

; on boucle sur tous les groupes d'icones
; bourrin : on met les mêmes icones partout
_hModule := DllCall("BeginUpdateResource", Str, f_AppExe, UInt, 0, Ptr)
Loop, parse, IconGroups, |
	{
	DeleteIcons(_hmodule, A_LoopField, 1033, f_AppExe)
	ReplaceIcons(_hmodule, f_Ico, A_LoopField, 1033, f_AppExe)
	}
DllCall("EndUpdateResource", Ptr, _hModule, UInt, 0)

UpdateProgress(2)

; on crée les patches binaires
Loop, parse, s_PEToPatch, `n, `r
	{
	If (A_LoopField = s_OldName . ".exe")
		RunWait, %f_diffExe% "%f_AppExe%" "%p_ArchiveDir%\%A_LoopField%" "%p_ArchiveDir%\%A_LoopField%.patch", , Hide
	Else
		RunWait, %f_diffExe% "%p_AppDir%\%A_LoopField%" "%p_ArchiveDir%\%A_LoopField%" "%p_ArchiveDir%\%A_LoopField%.patch", , Hide
	FileDelete, %p_ArchiveDir%\%A_LoopField%
	UpdateProgress(Ceil(35 / i_PE))
	}

FileAppend, %_ArchFiles%, %f_BKL%
FileDelete, %f_BKA%
RunWait, "%f_7zExe%" a -mx9 "%f_BKA%" @"%f_BKL%", %p_ArchiveDir%, Hide

UpdateProgress(2)

; on modifie user.js
FileSetTime, , %p_BaseDir%\App\DefaultData\user.js
; et install.rdf
FileGetVersion, s_maxVer, %f_AppExe%
s_maxVer := SubStr(s_maxVer, 1, InStr(s_maxVer, ".")) . "*"
FileRead, s_FKext, %p_AppDir%\distribution\bundles\framabrand@framakey.org\install.rdf
s_FKext := RegExReplace(s_FKext, "<em:maxVersion>(.*)</em:maxVersion>", "<em:maxVersion>" . s_maxVer . "</em:maxVersion>", 1)
FileDelete, %p_AppDir%\distribution\bundles\framabrand@framakey.org\install.rdf
FileAppend, %s_FKext%, %p_AppDir%\distribution\bundles\framabrand@framakey.org\install.rdf

UpdateProgress(2)

; on copie les fichiers de remplacement
FileMoveDir, %p_PlugDir%\files, %p_AppDir%, 1
; on met à jour les fichiers XML d'update
FileCopy, %p_AppDir%\updates.xml, %p_AppDir%\active-update.xml, 1

i_Bar := 99

UpdateProgress(1)

Sleep 200
If (s_Relaunch = "relaunch")
	Run, %f_PortLaunch%, %p_BaseDir%

ExitApp

; ================================================================================
; 								Fonctions
; ================================================================================


EnumResNameProc( _hModule, lpszType, lpszName, lParam )
{ 
	Global IconGroups
	IconGroups .= ( ( IconGroups!="" ) ? "|" : "" ) . lpszName 
	Return True 
}

EnumResLangProc( _hModule, lpszType, lpszName, wIDLanguage, lParam )
{ 
	Global i_LangID
	i_LangID .= ( ( i_LangID!="" ) ? "|" : "" ) . wIDLanguage
	Return True 
} 

UpdateProgress(i_BarPlus)
{
	Global i_Bar, s_AppName, _finmess
	i_Bar += i_BarPlus
	Progress, %i_Bar%, , %s_AppName% installe les mises à jour et %_finmess%. Veuillez patienter., Mise à jour

}

;===============================================================================
; 							Subroutines
;===============================================================================

QuitRebrand:
	; On efface le dossier temporaire
	FileRemoveDir, %p_PlugDir%, 1
ExitApp
